<template>
	<div
		:id="id"
		:class="[
			$style.block,
			$style[`size-${quoteSize.toLowerCase()}`],
			{
				[$style.reviewBackground]:
					reviewProduct === 'Review' && ((imageMobile && imageMobile.url) || (imageDesktop && imageDesktop.url)),
			},
			{
				[$style.minHeight]:
					reviewProduct === 'Review' && !((imageMobile && imageMobile.url) || (imageDesktop && imageDesktop.url)),
			},
		]"
		:style="{ backgroundColor }"
	>
		<BaseImage :image="imageMobile" :images="{ medium: imageDesktop }" compression-level="medium" sizes="100vw" />
		<div :class="$style.overlay">
			<div :class="$style.overlayInner">
				<div :class="$style.top" :style="{ color: productInfoColor || '#000' }">
					<div v-if="productName" :class="$style.productName">{{ productName }}</div>
					<MoleculeReviewInfo
						v-if="powerReviewsPageId"
						:link="reviewsLink && reviewsLink.url"
						:page-id="powerReviewsPageId"
					/>
				</div>
				<div :class="$style.middle" :style="{ color: quoteColor || '#fff' }">
					<blockquote :class="$style.quote">
						<p :style="$style.quoteText">{{ quote }}</p>
						<footer v-if="quoteAuthor" :class="$style.quoteAuthor">{{ quoteAuthor }}</footer>
					</blockquote>
				</div>
				<div :class="$style.bottom" :style="{ color: ctaColor || '#fff' }">
					<div v-if="ctaLink && ctaLink.url" :class="$style.buttonWrapper">
						<BaseButtonAuto
							:smart="ctaLink.url"
							:target="ctaLink.target"
							:appearance="ctaVariant"
							:class="$style.button"
							size="medium"
							force-color
						>
							{{ ctaText || ctaLink.url }}
						</BaseButtonAuto>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import MoleculeReviewInfo from '@components/molecule-review-info';
export default {
	components: {
		MoleculeReviewInfo,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		critical: {
			type: Boolean,
			default: true,
		},

		imageMobile: {
			type: Object,
			default: () => ({}),
		},

		imageDesktop: {
			type: Object,
			default: () => ({}),
		},

		productName: {
			type: String,
			default: '',
		},

		powerReviewsPageId: {
			type: String,
			default: '',
		},

		reviewsLink: {
			type: Object,
			default: () => ({}),
		},

		productInfoColor: {
			type: String,
			default: null,
		},

		quote: {
			type: String,
			required: true,
		},

		quoteAuthor: {
			type: String,
			default: '',
		},

		quoteColor: {
			type: String,
			default: null,
		},

		quoteSize: {
			type: String,
			default: '',
		},

		ctaLink: {
			type: Object,
			default: null,
		},

		ctaText: {
			type: String,
			default: '',
		},

		ctaColor: {
			type: String,
			default: null,
		},

		ctaVariant: {
			type: String,
			default: '',
		},

		backgroundColor: {
			type: String,
			default: '',
		},
		reviewProduct: {
			type: String,
			default: '',
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	position: relative;
}

.minHeight {
	min-height: 66.4rem;

	@include above('medium') {
		min-height: 77rem;
	}
}

.reviewBackground {
	text-align: left;
}

.overlay {
	position: absolute;
	top: 0;
	left: 0;
	display: flex;
	width: 100%;
	height: 100%;
	padding: 5rem 4rem;

	@include above('medium') {
		padding: 6rem 4rem 6rem;
	}
}

.overlayInner {
	position: relative;
	display: flex;
	flex: 0 0 auto;
	align-items: center;
	width: 100%;
}

.top,
.bottom {
	position: absolute;
	left: 0;
	width: 100%;
}

.top {
	top: 0;
	display: flex;
	flex-direction: column;
	align-items: center;
}

.productName {
	@include font-family('secondary');
	@include use-text-style('heading-100');

	margin-bottom: size('xxs');
}

.middle {
	width: 100%;

	@include below('medium') {
		margin-top: 5rem;
	}
}

.quote {
	@include font-family('secondary');

	text-align: center;

	.size-default & {
		@include use-text-style('heading-100');

		@include above('large') {
			@include use-text-style('heading-180');
		}
	}

	.size-bigger & {
		@include use-text-style('heading-500');

		@include above('medium') {
			@include use-text-style('heading-400');
		}

		@include above('large') {
			@include use-text-style('heading-900');
		}
	}

	.reviewBackground & {
		@include above('medium') {
			margin-right: 7.2rem;
			margin-left: 45%;
		}

		@include above('large') {
			margin-right: 14.4rem;
			margin-left: 58%;
		}
	}
}

.quoteAuthor {
	margin-top: 1em;
	font-style: italic;
}

.bottom {
	bottom: 0;
}

.buttonWrapper {
	display: flex;
	justify-content: center;
}

.button {
	.reviewBackground & {
		@include above('medium') {
			margin-left: 33%;
		}

		@include above('large') {
			margin-left: 45%;
		}
	}
}
</style>
